import SelT
import Data.List (maximumBy, minimumBy)
import Data.Ord (comparing)

data Move    = Cautious | Risky deriving (Show)
type Outcome = Int
type P a = [a]

q :: [Move] -> P Outcome
q [Cautious, Cautious] = [0]
q [Cautious, Risky]    = [-1, 0, 1]
q [Risky, Cautious]    = [-1, 0, 1]
q [Risky, Risky]       = [-2, -1, 0, 1, 2]

type Choice = P (Move, P Outcome) -> (Move, P Outcome)

argopt :: Choice -> SelT Outcome [] Move
argopt f = SelT $ \p -> [fst $ f [(Cautious, p Cautious), (Risky, p Risky)]]

riskymax, riskymin, cautiousmax, cautiousmin :: Choice
riskymax = maximumBy $ comparing $ maximum . snd
riskymin = minimumBy $ comparing $ minimum . snd
cautiousmax = riskymax . filter (all (>= (-1)) . snd)
cautiousmin = riskymin . filter (all (<= 1) . snd)

es1, es2, es3, es4 :: [SelT Outcome [] Move]
es1 = [argopt riskymax, argopt riskymin]
es2 = [argopt riskymax, argopt cautiousmin]
es3 = [argopt cautiousmax, argopt riskymin]
es4 = [argopt cautiousmax, argopt cautiousmin]

solve :: [SelT Outcome [] Move] -> P [Move]
solve es = runSelT (sequence es) q
